{
    "$graph": [
        {
            "class": "Workflow",
            "id": "#kfdrc_bam_to_gvcf.cwl",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "int",
                    "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/conditional_run"
                },
                {
                    "type": "File",
                    "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/contamination_sites_bed"
                },
                {
                    "type": "File",
                    "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/contamination_sites_mu"
                },
                {
                    "type": "File",
                    "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/contamination_sites_ud"
                },
                {
                    "type": "File",
                    "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/dbsnp_vcf"
                },
                {
                    "type": "File",
                    "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/indexed_reference_fasta"
                },
                {
                    "type": "File",
                    "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/input_bam"
                },
                {
                    "type": "string",
                    "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/output_basename"
                },
                {
                    "type": "File",
                    "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/reference_dict"
                },
                {
                    "type": "File",
                    "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/wgs_calling_interval_list"
                },
                {
                    "type": "File",
                    "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/wgs_evaluation_interval_list"
                }
            ],
            "steps": [
                {
                    "hints": [
                        {
                            "class": "https://sevenbridges.comAWSInstanceType",
                            "value": "c5.9xlarge"
                        }
                    ],
                    "run": "#gatk_haplotypecaller.cwl",
                    "in": [
                        {
                            "source": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/verifybamid/contamination",
                            "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/gatk_haplotypecaller/contamination"
                        },
                        {
                            "source": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/input_bam",
                            "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/gatk_haplotypecaller/input_bam"
                        },
                        {
                            "source": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/picard_intervallisttools/output",
                            "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/gatk_haplotypecaller/interval_list"
                        },
                        {
                            "source": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/indexed_reference_fasta",
                            "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/gatk_haplotypecaller/reference"
                        }
                    ],
                    "scatter": [
                        "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/gatk_haplotypecaller/interval_list"
                    ],
                    "out": [
                        "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/gatk_haplotypecaller/output"
                    ],
                    "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/gatk_haplotypecaller"
                },
                {
                    "run": "#picard_collectgvcfcallingmetrics.cwl",
                    "in": [
                        {
                            "source": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/dbsnp_vcf",
                            "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/picard_collectgvcfcallingmetrics/dbsnp_vcf"
                        },
                        {
                            "source": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/output_basename",
                            "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/picard_collectgvcfcallingmetrics/final_gvcf_base_name"
                        },
                        {
                            "source": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/picard_mergevcfs/output",
                            "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/picard_collectgvcfcallingmetrics/input_vcf"
                        },
                        {
                            "source": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/reference_dict",
                            "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/picard_collectgvcfcallingmetrics/reference_dict"
                        },
                        {
                            "source": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/wgs_evaluation_interval_list",
                            "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/picard_collectgvcfcallingmetrics/wgs_evaluation_interval_list"
                        }
                    ],
                    "out": [
                        "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/picard_collectgvcfcallingmetrics/output"
                    ],
                    "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/picard_collectgvcfcallingmetrics"
                },
                {
                    "run": "#picard_intervallisttools.cwl",
                    "in": [
                        {
                            "source": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/wgs_calling_interval_list",
                            "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/picard_intervallisttools/interval_list"
                        }
                    ],
                    "out": [
                        "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/picard_intervallisttools/output"
                    ],
                    "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/picard_intervallisttools"
                },
                {
                    "run": "#picard_mergevcfs.cwl",
                    "in": [
                        {
                            "source": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/gatk_haplotypecaller/output",
                            "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/picard_mergevcfs/input_vcf"
                        },
                        {
                            "source": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/output_basename",
                            "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/picard_mergevcfs/output_vcf_basename"
                        }
                    ],
                    "out": [
                        "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/picard_mergevcfs/output"
                    ],
                    "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/picard_mergevcfs"
                },
                {
                    "run": "#verifybamid_contamination.cwl",
                    "in": [
                        {
                            "source": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/contamination_sites_bed",
                            "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/verifybamid/contamination_sites_bed"
                        },
                        {
                            "source": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/contamination_sites_mu",
                            "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/verifybamid/contamination_sites_mu"
                        },
                        {
                            "source": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/contamination_sites_ud",
                            "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/verifybamid/contamination_sites_ud"
                        },
                        {
                            "source": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/input_bam",
                            "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/verifybamid/input_bam"
                        },
                        {
                            "source": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/output_basename",
                            "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/verifybamid/output_basename"
                        },
                        {
                            "source": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/indexed_reference_fasta",
                            "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/verifybamid/ref_fasta"
                        }
                    ],
                    "out": [
                        "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/verifybamid/output",
                        "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/verifybamid/contamination"
                    ],
                    "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/verifybamid"
                }
            ],
            "hints": [
                {
                    "class": "https://sevenbridges.commaxNumberOfParallelInstances",
                    "value": 4
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/picard_mergevcfs/output",
                    "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/gvcf"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/picard_collectgvcfcallingmetrics/output",
                    "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/gvcf_calling_metrics"
                },
                {
                    "type": "File",
                    "outputSource": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/verifybamid/output",
                    "id": "#kfdrc_bam_to_gvcf.cwl/kf_bam_contamination_wf/verifybamid_output"
                }
            ]
        },
        {
            "class": "Workflow",
            "id": "#kfdrc_process_bam.cwl",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".64.amb",
                        ".64.ann",
                        ".64.bwt",
                        ".64.pac",
                        ".64.sa",
                        ".64.alt",
                        "^.dict"
                    ],
                    "id": "#kfdrc_process_bam.cwl/kfdrc_process_bam/indexed_reference_fasta"
                },
                {
                    "type": "File",
                    "id": "#kfdrc_process_bam.cwl/kfdrc_process_bam/input_bam"
                },
                {
                    "type": "string",
                    "id": "#kfdrc_process_bam.cwl/kfdrc_process_bam/sample_name"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "array",
                            "items": "File"
                        }
                    },
                    "outputSource": "#kfdrc_process_bam.cwl/kfdrc_process_bam/realign_split_bam/unsorted_bams",
                    "id": "#kfdrc_process_bam.cwl/kfdrc_process_bam/unsorted_bams"
                }
            ],
            "steps": [
                {
                    "run": "#kfdrc_rgbam_to_realnbam.cwl",
                    "in": [
                        {
                            "source": "#kfdrc_process_bam.cwl/kfdrc_process_bam/indexed_reference_fasta",
                            "id": "#kfdrc_process_bam.cwl/kfdrc_process_bam/realign_split_bam/indexed_reference_fasta"
                        },
                        {
                            "source": "#kfdrc_process_bam.cwl/kfdrc_process_bam/samtools_split/bam_files",
                            "id": "#kfdrc_process_bam.cwl/kfdrc_process_bam/realign_split_bam/input_rgbam"
                        },
                        {
                            "source": "#kfdrc_process_bam.cwl/kfdrc_process_bam/sample_name",
                            "id": "#kfdrc_process_bam.cwl/kfdrc_process_bam/realign_split_bam/sample_name"
                        }
                    ],
                    "scatter": [
                        "#kfdrc_process_bam.cwl/kfdrc_process_bam/realign_split_bam/input_rgbam"
                    ],
                    "out": [
                        "#kfdrc_process_bam.cwl/kfdrc_process_bam/realign_split_bam/unsorted_bams"
                    ],
                    "id": "#kfdrc_process_bam.cwl/kfdrc_process_bam/realign_split_bam"
                },
                {
                    "run": "#samtools_split.cwl",
                    "in": [
                        {
                            "source": "#kfdrc_process_bam.cwl/kfdrc_process_bam/input_bam",
                            "id": "#kfdrc_process_bam.cwl/kfdrc_process_bam/samtools_split/input_bam"
                        },
                        {
                            "source": "#kfdrc_process_bam.cwl/kfdrc_process_bam/indexed_reference_fasta",
                            "id": "#kfdrc_process_bam.cwl/kfdrc_process_bam/samtools_split/reference"
                        }
                    ],
                    "out": [
                        "#kfdrc_process_bam.cwl/kfdrc_process_bam/samtools_split/bam_files"
                    ],
                    "id": "#kfdrc_process_bam.cwl/kfdrc_process_bam/samtools_split"
                }
            ]
        },
        {
            "class": "Workflow",
            "id": "#kfdrc_process_bamlist.cwl",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "int",
                    "id": "#kfdrc_process_bamlist.cwl/kfdrc_process_bamlist/conditional_run"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".64.amb",
                        ".64.ann",
                        ".64.bwt",
                        ".64.pac",
                        ".64.sa",
                        ".64.alt",
                        "^.dict"
                    ],
                    "id": "#kfdrc_process_bamlist.cwl/kfdrc_process_bamlist/indexed_reference_fasta"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#kfdrc_process_bamlist.cwl/kfdrc_process_bamlist/input_bam_list"
                },
                {
                    "type": "string",
                    "id": "#kfdrc_process_bamlist.cwl/kfdrc_process_bamlist/sample_name"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "array",
                            "items": {
                                "type": "array",
                                "items": "File"
                            }
                        }
                    },
                    "outputSource": "#kfdrc_process_bamlist.cwl/kfdrc_process_bamlist/process_bams/unsorted_bams",
                    "id": "#kfdrc_process_bamlist.cwl/kfdrc_process_bamlist/unsorted_bams"
                }
            ],
            "steps": [
                {
                    "run": "#kfdrc_process_bam.cwl",
                    "in": [
                        {
                            "source": "#kfdrc_process_bamlist.cwl/kfdrc_process_bamlist/indexed_reference_fasta",
                            "id": "#kfdrc_process_bamlist.cwl/kfdrc_process_bamlist/process_bams/indexed_reference_fasta"
                        },
                        {
                            "source": "#kfdrc_process_bamlist.cwl/kfdrc_process_bamlist/input_bam_list",
                            "id": "#kfdrc_process_bamlist.cwl/kfdrc_process_bamlist/process_bams/input_bam"
                        },
                        {
                            "source": "#kfdrc_process_bamlist.cwl/kfdrc_process_bamlist/sample_name",
                            "id": "#kfdrc_process_bamlist.cwl/kfdrc_process_bamlist/process_bams/sample_name"
                        }
                    ],
                    "scatter": "#kfdrc_process_bamlist.cwl/kfdrc_process_bamlist/process_bams/input_bam",
                    "out": [
                        "#kfdrc_process_bamlist.cwl/kfdrc_process_bamlist/process_bams/unsorted_bams"
                    ],
                    "id": "#kfdrc_process_bamlist.cwl/kfdrc_process_bamlist/process_bams"
                }
            ],
            "hints": [
                {
                    "class": "https://sevenbridges.commaxNumberOfParallelInstances",
                    "value": 4
                }
            ]
        },
        {
            "class": "Workflow",
            "id": "#kfdrc_process_pe_readslist2.cwl",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "int",
                    "id": "#kfdrc_process_pe_readslist2.cwl/kfdrc_process_pe_readslist2/conditional_run"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".64.amb",
                        ".64.ann",
                        ".64.bwt",
                        ".64.pac",
                        ".64.sa",
                        ".64.alt",
                        "^.dict"
                    ],
                    "id": "#kfdrc_process_pe_readslist2.cwl/kfdrc_process_pe_readslist2/indexed_reference_fasta"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#kfdrc_process_pe_readslist2.cwl/kfdrc_process_pe_readslist2/input_pe_mates_list"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#kfdrc_process_pe_readslist2.cwl/kfdrc_process_pe_readslist2/input_pe_reads_list"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#kfdrc_process_pe_readslist2.cwl/kfdrc_process_pe_readslist2/input_pe_rgs_list"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "array",
                            "items": "File"
                        }
                    },
                    "outputSource": "#kfdrc_process_pe_readslist2.cwl/kfdrc_process_pe_readslist2/process_pe_set/unsorted_bams",
                    "id": "#kfdrc_process_pe_readslist2.cwl/kfdrc_process_pe_readslist2/unsorted_bams"
                }
            ],
            "steps": [
                {
                    "run": "#kfdrc_process_pe_set.cwl",
                    "in": [
                        {
                            "source": "#kfdrc_process_pe_readslist2.cwl/kfdrc_process_pe_readslist2/indexed_reference_fasta",
                            "id": "#kfdrc_process_pe_readslist2.cwl/kfdrc_process_pe_readslist2/process_pe_set/indexed_reference_fasta"
                        },
                        {
                            "source": "#kfdrc_process_pe_readslist2.cwl/kfdrc_process_pe_readslist2/input_pe_mates_list",
                            "id": "#kfdrc_process_pe_readslist2.cwl/kfdrc_process_pe_readslist2/process_pe_set/input_pe_mates"
                        },
                        {
                            "source": "#kfdrc_process_pe_readslist2.cwl/kfdrc_process_pe_readslist2/input_pe_reads_list",
                            "id": "#kfdrc_process_pe_readslist2.cwl/kfdrc_process_pe_readslist2/process_pe_set/input_pe_reads"
                        },
                        {
                            "source": "#kfdrc_process_pe_readslist2.cwl/kfdrc_process_pe_readslist2/input_pe_rgs_list",
                            "id": "#kfdrc_process_pe_readslist2.cwl/kfdrc_process_pe_readslist2/process_pe_set/input_pe_rgs"
                        }
                    ],
                    "scatter": [
                        "#kfdrc_process_pe_readslist2.cwl/kfdrc_process_pe_readslist2/process_pe_set/input_pe_reads",
                        "#kfdrc_process_pe_readslist2.cwl/kfdrc_process_pe_readslist2/process_pe_set/input_pe_mates",
                        "#kfdrc_process_pe_readslist2.cwl/kfdrc_process_pe_readslist2/process_pe_set/input_pe_rgs"
                    ],
                    "scatterMethod": "dotproduct",
                    "out": [
                        "#kfdrc_process_pe_readslist2.cwl/kfdrc_process_pe_readslist2/process_pe_set/unsorted_bams"
                    ],
                    "id": "#kfdrc_process_pe_readslist2.cwl/kfdrc_process_pe_readslist2/process_pe_set"
                }
            ],
            "hints": [
                {
                    "class": "https://sevenbridges.commaxNumberOfParallelInstances",
                    "value": 4
                }
            ]
        },
        {
            "class": "Workflow",
            "id": "#kfdrc_process_pe_set.cwl",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".64.amb",
                        ".64.ann",
                        ".64.bwt",
                        ".64.pac",
                        ".64.sa",
                        ".64.alt",
                        "^.dict"
                    ],
                    "id": "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/indexed_reference_fasta"
                },
                {
                    "type": "File",
                    "id": "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/input_pe_mates"
                },
                {
                    "type": "File",
                    "id": "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/input_pe_reads"
                },
                {
                    "type": "string",
                    "id": "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/input_pe_rgs"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/bwa_mem_split_pe_reads/output",
                    "id": "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/unsorted_bams"
                }
            ],
            "steps": [
                {
                    "run": "#bwa_mem_naive.cwl",
                    "in": [
                        {
                            "source": "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/zcat_split_mates/output",
                            "id": "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/bwa_mem_split_pe_reads/mates"
                        },
                        {
                            "source": "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/zcat_split_reads/output",
                            "id": "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/bwa_mem_split_pe_reads/reads"
                        },
                        {
                            "source": "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/indexed_reference_fasta",
                            "id": "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/bwa_mem_split_pe_reads/ref"
                        },
                        {
                            "source": "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/input_pe_rgs",
                            "id": "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/bwa_mem_split_pe_reads/rg"
                        }
                    ],
                    "scatter": [
                        "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/bwa_mem_split_pe_reads/reads",
                        "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/bwa_mem_split_pe_reads/mates"
                    ],
                    "scatterMethod": "dotproduct",
                    "out": [
                        "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/bwa_mem_split_pe_reads/output"
                    ],
                    "id": "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/bwa_mem_split_pe_reads"
                },
                {
                    "hints": [
                        {
                            "class": "https://sevenbridges.comAWSInstanceType",
                            "value": "c5.9xlarge"
                        }
                    ],
                    "run": "#fastq_chomp.cwl",
                    "in": [
                        {
                            "source": "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/input_pe_mates",
                            "id": "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/zcat_split_mates/input_fastq"
                        }
                    ],
                    "out": [
                        "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/zcat_split_mates/output"
                    ],
                    "id": "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/zcat_split_mates"
                },
                {
                    "hints": [
                        {
                            "class": "https://sevenbridges.comAWSInstanceType",
                            "value": "c5.9xlarge"
                        }
                    ],
                    "run": "#fastq_chomp.cwl",
                    "in": [
                        {
                            "source": "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/input_pe_reads",
                            "id": "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/zcat_split_reads/input_fastq"
                        }
                    ],
                    "out": [
                        "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/zcat_split_reads/output"
                    ],
                    "id": "#kfdrc_process_pe_set.cwl/kfdrc_process_pe_set/zcat_split_reads"
                }
            ],
            "hints": [
                {
                    "class": "https://sevenbridges.commaxNumberOfParallelInstances",
                    "value": 4
                }
            ]
        },
        {
            "class": "Workflow",
            "id": "#kfdrc_process_se_readslist2.cwl",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "int",
                    "id": "#kfdrc_process_se_readslist2.cwl/kfdrc_process_se_readslist2/conditional_run"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".64.amb",
                        ".64.ann",
                        ".64.bwt",
                        ".64.pac",
                        ".64.sa",
                        ".64.alt",
                        "^.dict"
                    ],
                    "id": "#kfdrc_process_se_readslist2.cwl/kfdrc_process_se_readslist2/indexed_reference_fasta"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#kfdrc_process_se_readslist2.cwl/kfdrc_process_se_readslist2/input_se_reads_list"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#kfdrc_process_se_readslist2.cwl/kfdrc_process_se_readslist2/input_se_rgs_list"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "array",
                            "items": "File"
                        }
                    },
                    "outputSource": "#kfdrc_process_se_readslist2.cwl/kfdrc_process_se_readslist2/process_se_set/unsorted_bams",
                    "id": "#kfdrc_process_se_readslist2.cwl/kfdrc_process_se_readslist2/unsorted_bams"
                }
            ],
            "steps": [
                {
                    "run": "#kfdrc_process_se_set.cwl",
                    "in": [
                        {
                            "source": "#kfdrc_process_se_readslist2.cwl/kfdrc_process_se_readslist2/indexed_reference_fasta",
                            "id": "#kfdrc_process_se_readslist2.cwl/kfdrc_process_se_readslist2/process_se_set/indexed_reference_fasta"
                        },
                        {
                            "source": "#kfdrc_process_se_readslist2.cwl/kfdrc_process_se_readslist2/input_se_reads_list",
                            "id": "#kfdrc_process_se_readslist2.cwl/kfdrc_process_se_readslist2/process_se_set/input_se_reads"
                        },
                        {
                            "source": "#kfdrc_process_se_readslist2.cwl/kfdrc_process_se_readslist2/input_se_rgs_list",
                            "id": "#kfdrc_process_se_readslist2.cwl/kfdrc_process_se_readslist2/process_se_set/input_se_rgs"
                        }
                    ],
                    "scatter": [
                        "#kfdrc_process_se_readslist2.cwl/kfdrc_process_se_readslist2/process_se_set/input_se_reads",
                        "#kfdrc_process_se_readslist2.cwl/kfdrc_process_se_readslist2/process_se_set/input_se_rgs"
                    ],
                    "scatterMethod": "dotproduct",
                    "out": [
                        "#kfdrc_process_se_readslist2.cwl/kfdrc_process_se_readslist2/process_se_set/unsorted_bams"
                    ],
                    "id": "#kfdrc_process_se_readslist2.cwl/kfdrc_process_se_readslist2/process_se_set"
                }
            ],
            "hints": [
                {
                    "class": "https://sevenbridges.commaxNumberOfParallelInstances",
                    "value": 4
                }
            ]
        },
        {
            "class": "Workflow",
            "id": "#kfdrc_process_se_set.cwl",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".64.amb",
                        ".64.ann",
                        ".64.bwt",
                        ".64.pac",
                        ".64.sa",
                        ".64.alt",
                        "^.dict"
                    ],
                    "id": "#kfdrc_process_se_set.cwl/kfdrc_process_se_set/indexed_reference_fasta"
                },
                {
                    "type": "File",
                    "id": "#kfdrc_process_se_set.cwl/kfdrc_process_se_set/input_se_reads"
                },
                {
                    "type": "string",
                    "id": "#kfdrc_process_se_set.cwl/kfdrc_process_se_set/input_se_rgs"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#kfdrc_process_se_set.cwl/kfdrc_process_se_set/bwa_mem_split_se_reads/output",
                    "id": "#kfdrc_process_se_set.cwl/kfdrc_process_se_set/unsorted_bams"
                }
            ],
            "steps": [
                {
                    "run": "#bwa_mem_naive.cwl",
                    "in": [
                        {
                            "source": "#kfdrc_process_se_set.cwl/kfdrc_process_se_set/zcat_split_reads/output",
                            "id": "#kfdrc_process_se_set.cwl/kfdrc_process_se_set/bwa_mem_split_se_reads/reads"
                        },
                        {
                            "source": "#kfdrc_process_se_set.cwl/kfdrc_process_se_set/indexed_reference_fasta",
                            "id": "#kfdrc_process_se_set.cwl/kfdrc_process_se_set/bwa_mem_split_se_reads/ref"
                        },
                        {
                            "source": "#kfdrc_process_se_set.cwl/kfdrc_process_se_set/input_se_rgs",
                            "id": "#kfdrc_process_se_set.cwl/kfdrc_process_se_set/bwa_mem_split_se_reads/rg"
                        }
                    ],
                    "scatter": "#kfdrc_process_se_set.cwl/kfdrc_process_se_set/bwa_mem_split_se_reads/reads",
                    "out": [
                        "#kfdrc_process_se_set.cwl/kfdrc_process_se_set/bwa_mem_split_se_reads/output"
                    ],
                    "id": "#kfdrc_process_se_set.cwl/kfdrc_process_se_set/bwa_mem_split_se_reads"
                },
                {
                    "hints": [
                        {
                            "class": "https://sevenbridges.comAWSInstanceType",
                            "value": "c5.9xlarge"
                        }
                    ],
                    "run": "#fastq_chomp.cwl",
                    "in": [
                        {
                            "source": "#kfdrc_process_se_set.cwl/kfdrc_process_se_set/input_se_reads",
                            "id": "#kfdrc_process_se_set.cwl/kfdrc_process_se_set/zcat_split_reads/input_fastq"
                        }
                    ],
                    "out": [
                        "#kfdrc_process_se_set.cwl/kfdrc_process_se_set/zcat_split_reads/output"
                    ],
                    "id": "#kfdrc_process_se_set.cwl/kfdrc_process_se_set/zcat_split_reads"
                }
            ],
            "hints": [
                {
                    "class": "https://sevenbridges.commaxNumberOfParallelInstances",
                    "value": 4
                }
            ]
        },
        {
            "class": "Workflow",
            "id": "#kfdrc_rgbam_to_realnbam.cwl",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".64.amb",
                        ".64.ann",
                        ".64.bwt",
                        ".64.pac",
                        ".64.sa",
                        ".64.alt",
                        "^.dict"
                    ],
                    "id": "#kfdrc_rgbam_to_realnbam.cwl/kfdrc_rgbam_to_realnbam_wf/indexed_reference_fasta"
                },
                {
                    "type": "File",
                    "id": "#kfdrc_rgbam_to_realnbam.cwl/kfdrc_rgbam_to_realnbam_wf/input_rgbam"
                },
                {
                    "type": "string",
                    "id": "#kfdrc_rgbam_to_realnbam.cwl/kfdrc_rgbam_to_realnbam_wf/sample_name"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#kfdrc_rgbam_to_realnbam.cwl/kfdrc_rgbam_to_realnbam_wf/bwa_mem_naive_bam/output",
                    "id": "#kfdrc_rgbam_to_realnbam.cwl/kfdrc_rgbam_to_realnbam_wf/unsorted_bams"
                }
            ],
            "steps": [
                {
                    "run": "#bamtofastq_chomp.cwl",
                    "in": [
                        {
                            "source": "#kfdrc_rgbam_to_realnbam.cwl/kfdrc_rgbam_to_realnbam_wf/input_rgbam",
                            "id": "#kfdrc_rgbam_to_realnbam.cwl/kfdrc_rgbam_to_realnbam_wf/bamtofastq_chomp/input_bam"
                        },
                        {
                            "source": "#kfdrc_rgbam_to_realnbam.cwl/kfdrc_rgbam_to_realnbam_wf/sample_name",
                            "id": "#kfdrc_rgbam_to_realnbam.cwl/kfdrc_rgbam_to_realnbam_wf/bamtofastq_chomp/sample"
                        }
                    ],
                    "out": [
                        "#kfdrc_rgbam_to_realnbam.cwl/kfdrc_rgbam_to_realnbam_wf/bamtofastq_chomp/output",
                        "#kfdrc_rgbam_to_realnbam.cwl/kfdrc_rgbam_to_realnbam_wf/bamtofastq_chomp/rg_string"
                    ],
                    "id": "#kfdrc_rgbam_to_realnbam.cwl/kfdrc_rgbam_to_realnbam_wf/bamtofastq_chomp"
                },
                {
                    "run": "#bwa_mem_naive.cwl",
                    "in": [
                        {
                            "default": true,
                            "id": "#kfdrc_rgbam_to_realnbam.cwl/kfdrc_rgbam_to_realnbam_wf/bwa_mem_naive_bam/interleaved"
                        },
                        {
                            "source": "#kfdrc_rgbam_to_realnbam.cwl/kfdrc_rgbam_to_realnbam_wf/bamtofastq_chomp/output",
                            "id": "#kfdrc_rgbam_to_realnbam.cwl/kfdrc_rgbam_to_realnbam_wf/bwa_mem_naive_bam/reads"
                        },
                        {
                            "source": "#kfdrc_rgbam_to_realnbam.cwl/kfdrc_rgbam_to_realnbam_wf/indexed_reference_fasta",
                            "id": "#kfdrc_rgbam_to_realnbam.cwl/kfdrc_rgbam_to_realnbam_wf/bwa_mem_naive_bam/ref"
                        },
                        {
                            "source": "#kfdrc_rgbam_to_realnbam.cwl/kfdrc_rgbam_to_realnbam_wf/bamtofastq_chomp/rg_string",
                            "id": "#kfdrc_rgbam_to_realnbam.cwl/kfdrc_rgbam_to_realnbam_wf/bwa_mem_naive_bam/rg"
                        }
                    ],
                    "scatter": [
                        "#kfdrc_rgbam_to_realnbam.cwl/kfdrc_rgbam_to_realnbam_wf/bwa_mem_naive_bam/reads"
                    ],
                    "out": [
                        "#kfdrc_rgbam_to_realnbam.cwl/kfdrc_rgbam_to_realnbam_wf/bwa_mem_naive_bam/output"
                    ],
                    "id": "#kfdrc_rgbam_to_realnbam.cwl/kfdrc_rgbam_to_realnbam_wf/bwa_mem_naive_bam"
                }
            ],
            "hints": [
                {
                    "class": "https://sevenbridges.commaxNumberOfParallelInstances",
                    "value": 4
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#bamtofastq_chomp.cwl",
            "doc": "If the input BAM is not provided the program will simply exit without failing.\nThis tool runs two programs:\n  - samtools view && biobambam2 bamtofastq\nThe program will first grab the RG header from the input BAM and put it in a file.\nThis RG header in the text file is later parsed into a string.\nNext it will convert the bam to fastq. If the file is over the max_size, it will\nchunk the output FASTQ into 680 million line FASTQs (85 million read pairs).",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 1000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/bwa-bundle:dev"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "baseCommand": [
                "/bin/bash",
                "-c"
            ],
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": false,
                    "valueFrom": "set -eo pipefail\n\nsamtools view -H $(inputs.input_bam.path) | grep ^@RG > rg.txt\n\nif [ $(inputs.input_bam.size) -gt $(inputs.max_size) ]; then\n  bamtofastq tryoq=1 filename=$(inputs.input_bam.path) | split -dl 680000000 - reads-\n  ls reads-* | xargs -i mv {} {}.fq\nelse\n  bamtofastq tryoq=1 filename=$(inputs.input_bam.path) > reads-00.fq\nfi"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "doc": "Input bam file",
                    "id": "#bamtofastq_chomp.cwl/bamtofastq_chomp/input_bam"
                },
                {
                    "type": "long",
                    "default": 20000000000,
                    "doc": "The maximum size (in bytes) that an input bam can be before the FASTQ is split",
                    "id": "#bamtofastq_chomp.cwl/bamtofastq_chomp/max_size"
                },
                {
                    "type": "string",
                    "doc": "String name of the sample used to relabel the rg string",
                    "id": "#bamtofastq_chomp.cwl/bamtofastq_chomp/sample"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.fq"
                    },
                    "id": "#bamtofastq_chomp.cwl/bamtofastq_chomp/output"
                },
                {
                    "type": "string",
                    "outputBinding": {
                        "glob": "rg.txt",
                        "loadContents": true,
                        "outputEval": "${ var arr = self[0].contents.split('\\n')[0].split('\\t'); for (var i=1; i<arr.length; i++){ if (arr[i].startsWith('SM')){ arr[i] = 'SM:' + inputs.sample; } } return arr.join('\\\\t'); }"
                    },
                    "id": "#bamtofastq_chomp.cwl/bamtofastq_chomp/rg_string"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#bwa_mem_naive.cwl",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 50000,
                    "coresMin": 36
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "zhangb1/bwa-kf-bundle:0.1.17"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "baseCommand": [
                "/bin/bash",
                "-c"
            ],
            "doc": "The program can handle the following classes of inputs:\n - single end reads (only reads File and rg string provided)\n - reads with mates (reads File, mates File, and rg string provided)\n - interleaved reads (reads File provided, rg string provided, and interleaved set to true)\nThis tool runs the following programs:\n - bwa mem | samblaster | sambamba view | sambamba sort",
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": false,
                    "valueFrom": "set -eo pipefail\nbwa mem -K 100000000 ${if (inputs.interleaved) {return '-p';} else {return \"\"}} -v 3 -t 36 -Y $(inputs.ref.path) -R '${return inputs.rg}' ${return inputs.reads.path} ${if (inputs.mates != null) {return inputs.mates.path} else {return \"\"}} | /opt/samblaster/samblaster -i /dev/stdin -o /dev/stdout | /opt/sambamba_0.6.3/sambamba_v0.6.3 view -t 36 -f bam -l 0 -S /dev/stdin | /opt/sambamba_0.6.3/sambamba_v0.6.3 sort -t 36 --natural-sort -m 15GiB --tmpdir ./ -o ${if (inputs.reads != null) {return inputs.reads.nameroot} else {return \"\"}}.unsorted.bam -l 5 /dev/stdin"
                }
            ],
            "inputs": [
                {
                    "type": "boolean",
                    "default": false,
                    "doc": "The reads input is interleaved",
                    "id": "#bwa_mem_naive.cwl/bwa_mem_naive/interleaved"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "doc": "Mates file for the reads",
                    "id": "#bwa_mem_naive.cwl/bwa_mem_naive/mates"
                },
                {
                    "type": "File",
                    "doc": "Primary reads file",
                    "id": "#bwa_mem_naive.cwl/bwa_mem_naive/reads"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".64.amb",
                        ".64.ann",
                        ".64.bwt",
                        ".64.pac",
                        ".64.sa",
                        ".64.alt",
                        "^.dict",
                        ".amb",
                        ".ann",
                        ".bwt",
                        ".pac",
                        ".sa",
                        ".fai"
                    ],
                    "doc": "Reference fasta file with associated indexes",
                    "id": "#bwa_mem_naive.cwl/bwa_mem_naive/ref"
                },
                {
                    "type": "string",
                    "doc": "Formatted RG header to use in the resulting BAM, check BWA for formatting guidelines (e.g. escaped tabs '\\t')",
                    "id": "#bwa_mem_naive.cwl/bwa_mem_naive/rg"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.bam"
                    },
                    "id": "#bwa_mem_naive.cwl/bwa_mem_naive/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#fastq_chomp.cwl",
            "doc": "This tool will chomp any fastq larger than the max size (10 gb by default) into 320000000 line chunks (80M reads). \nPrograms used in this tool:\n  - zcat | split\n  - ls | mv",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 8000,
                    "coresMin": 4
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/bwa-bundle:dev"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "baseCommand": [
                "/bin/bash",
                "-c"
            ],
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": false,
                    "valueFrom": "set -eo pipefail\n\nif [ $(inputs.input_fastq.size) -gt $(inputs.max_size) ]; then\n  zcat $(inputs.input_fastq.path) | split -dl 320000000 - reads-\n  ls reads-* | xargs -i mv {} {}.fq\nelse\n  echo \"FASTQ not large enough to split.\"\nfi"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "doc": "Input fastq file",
                    "id": "#fastq_chomp.cwl/fastq_chomp/input_fastq"
                },
                {
                    "type": "long",
                    "default": 10000000000,
                    "doc": "The maximum size (in bytes) that an input bam can be before the FASTQ is split",
                    "id": "#fastq_chomp.cwl/fastq_chomp/max_size"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.fq",
                        "outputEval": "${\n  if (self.length == 0) return [inputs.input_fastq]\n  else return self\n}"
                    },
                    "id": "#fastq_chomp.cwl/fastq_chomp/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#gatekeeper.cwl",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "ubuntu:18.04"
                }
            ],
            "baseCommand": [
                "/bin/bash",
                "-c"
            ],
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": false,
                    "valueFrom": "set -eo pipefail\n${\n  if (inputs.run_bam_processing || inputs.run_pe_reads_processing ||  inputs.run_se_reads_processing) {\n    return \"echo Files Provided...Processing >&2 && exit 0\"\n  } else {\n    return \"echo No BAMs or FASTQs provided, mission accomplished >&2 && exit 1\"\n  }\n}"
                }
            ],
            "inputs": [
                {
                    "type": "boolean",
                    "id": "#gatekeeper.cwl/gatekeeper/run_agg_metrics"
                },
                {
                    "type": "boolean",
                    "id": "#gatekeeper.cwl/gatekeeper/run_bam_processing"
                },
                {
                    "type": "boolean",
                    "id": "#gatekeeper.cwl/gatekeeper/run_gvcf_processing"
                },
                {
                    "type": "boolean",
                    "id": "#gatekeeper.cwl/gatekeeper/run_hs_metrics"
                },
                {
                    "type": "boolean",
                    "id": "#gatekeeper.cwl/gatekeeper/run_pe_reads_processing"
                },
                {
                    "type": "boolean",
                    "id": "#gatekeeper.cwl/gatekeeper/run_se_reads_processing"
                },
                {
                    "type": "boolean",
                    "id": "#gatekeeper.cwl/gatekeeper/run_wgs_metrics"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "int"
                    },
                    "outputBinding": {
                        "outputEval": "${ if (inputs.run_agg_metrics) {return [1]} else {return []} }"
                    },
                    "id": "#gatekeeper.cwl/gatekeeper/scatter_agg_metrics"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "int"
                    },
                    "outputBinding": {
                        "outputEval": "${ if (inputs.run_bam_processing) {return [1]} else {return []} }"
                    },
                    "id": "#gatekeeper.cwl/gatekeeper/scatter_bams"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "int"
                    },
                    "outputBinding": {
                        "outputEval": "${ if (inputs.run_gvcf_processing) {return [1]} else {return []} }"
                    },
                    "id": "#gatekeeper.cwl/gatekeeper/scatter_gvcf"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "int"
                    },
                    "outputBinding": {
                        "outputEval": "${ if (inputs.run_hs_metrics) {return [1]} else {return []} }"
                    },
                    "id": "#gatekeeper.cwl/gatekeeper/scatter_hs_metrics"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "int"
                    },
                    "outputBinding": {
                        "outputEval": "${ if (inputs.run_pe_reads_processing) {return [1]} else {return []} }"
                    },
                    "id": "#gatekeeper.cwl/gatekeeper/scatter_pe_reads"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "int"
                    },
                    "outputBinding": {
                        "outputEval": "${ if (inputs.run_se_reads_processing) {return [1]} else {return []} }"
                    },
                    "id": "#gatekeeper.cwl/gatekeeper/scatter_se_reads"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "int"
                    },
                    "outputBinding": {
                        "outputEval": "${ if (inputs.run_wgs_metrics) {return [1]} else {return []} }"
                    },
                    "id": "#gatekeeper.cwl/gatekeeper/scatter_wgs_metrics"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#gatk_applybqsr.cwl",
            "doc": "This tool applies BQSR to the input bam.\nThe following programs are run in this tool:\n  - GATK ApplyBQSR",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/gatk:4.0.3.0"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4500
                }
            ],
            "baseCommand": [
                "/gatk",
                "ApplyBQSR"
            ],
            "arguments": [
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "--java-options \"-Xms3000m -XX:+PrintFlagsFinal -XX:+PrintGCTimeStamps -XX:+PrintGCDateStamps -XX:+PrintGCDetails -Xloggc:gc_log.log -XX:GCTimeLimit=50 -XX:GCHeapFreeLimit=10\" --create-output-bam-md5 --add-output-sam-program-record -R $(inputs.reference.path) -I $(inputs.input_bam.path) --use-original-qualities -O $(inputs.input_bam.nameroot).aligned.duplicates_marked.recalibrated.bam -bqsr $(inputs.bqsr_report.path) --static-quantized-quals 10 --static-quantized-quals 20 --static-quantized-quals 30 -L $(inputs.sequence_interval.path)"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "doc": "Input recalibration table for BQSR",
                    "id": "#gatk_applybqsr.cwl/gatk4_applybqsr/bqsr_report"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "doc": "Input bam file",
                    "id": "#gatk_applybqsr.cwl/gatk4_applybqsr/input_bam"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.dict",
                        ".fai"
                    ],
                    "doc": "Reference fasta with associated dict and fai indexes",
                    "id": "#gatk_applybqsr.cwl/gatk4_applybqsr/reference"
                },
                {
                    "type": "File",
                    "doc": "File containing one or more genomic intervals over which to operate",
                    "id": "#gatk_applybqsr.cwl/gatk4_applybqsr/sequence_interval"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*bam"
                    },
                    "secondaryFiles": [
                        "^.bai",
                        ".md5"
                    ],
                    "id": "#gatk_applybqsr.cwl/gatk4_applybqsr/recalibrated_bam"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#gatk_baserecalibrator.cwl",
            "doc": "Perform baserecalibration on a BAM.\nPrograms run in this tool:\n  - GATK BaseRecalibrator",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/gatk:4.0.3.0"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 8000
                }
            ],
            "baseCommand": [
                "/gatk",
                "BaseRecalibrator"
            ],
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": false,
                    "valueFrom": "--java-options \"-Xms4000m -XX:GCTimeLimit=50 -XX:GCHeapFreeLimit=10 -XX:+PrintFlagsFinal -XX:+PrintGCTimeStamps -XX:+PrintGCDateStamps -XX:+PrintGCDetails -Xloggc:gc_log.log\" -R $(inputs.reference.path) -I $(inputs.input_bam.path) --use-original-qualities -O $(inputs.input_bam.nameroot).recal_data.csv -L $(inputs.sequence_interval.path)"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "doc": "Input bam file",
                    "id": "#gatk_baserecalibrator.cwl/gatkv4_baserecalibrator/input_bam"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File",
                        "inputBinding": {
                            "prefix": "--known-sites"
                        }
                    },
                    "inputBinding": {
                        "position": 1
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "doc": "List of files and indexes containing known polymorphic sites used to exclude regions around known polymorphisms from analysis",
                    "id": "#gatk_baserecalibrator.cwl/gatkv4_baserecalibrator/knownsites"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.dict",
                        ".fai"
                    ],
                    "doc": "Reference fasta with dict and fai indexes",
                    "id": "#gatk_baserecalibrator.cwl/gatkv4_baserecalibrator/reference"
                },
                {
                    "type": "File",
                    "doc": "File containing one or more genomic intervals over which to operate",
                    "id": "#gatk_baserecalibrator.cwl/gatkv4_baserecalibrator/sequence_interval"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.recal_data.csv"
                    },
                    "id": "#gatk_baserecalibrator.cwl/gatkv4_baserecalibrator/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#gatk_gatherbqsrreports.cwl",
            "doc": "This tool gathers the BQSR reports.\nThe following programs are run in this tool:\n  - GATK GatherBQSRReports",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/gatk:4.0.3.0"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 8000
                }
            ],
            "baseCommand": [
                "/gatk",
                "GatherBQSRReports"
            ],
            "arguments": [
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "--java-options \"-Xms3000m\" -O $(inputs.output_basename).GatherBqsrReports.recal_data.csv"
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File",
                        "inputBinding": {
                            "prefix": "-I",
                            "separate": true
                        }
                    },
                    "doc": "List of bqsr report files",
                    "id": "#gatk_gatherbqsrreports.cwl/gatk_gatherbqsrreports/input_brsq_reports"
                },
                {
                    "type": "string",
                    "doc": "String to be used as the basename for the gathered bqsr report file",
                    "id": "#gatk_gatherbqsrreports.cwl/gatk_gatherbqsrreports/output_basename"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.csv"
                    },
                    "id": "#gatk_gatherbqsrreports.cwl/gatk_gatherbqsrreports/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#gatk_haplotypecaller.cwl",
            "doc": "This tool calls germline SNPs and indels via local re-assembly of haplotypes.\nThe following programs are run in this tool:\n  - GATK PrintReads\n  - GATK HaplotypeCaller",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 10000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/gatk:4.beta.1-3.5"
                }
            ],
            "baseCommand": [
                "/gatk-launch",
                "--javaOptions",
                "-Xms2000m"
            ],
            "arguments": [
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "PrintReads -I $(inputs.input_bam.path) --interval_padding 500 -L $(inputs.interval_list.path) -O local.sharded.bam && java -XX:GCTimeLimit=50 -XX:GCHeapFreeLimit=10 -Xms8000m -jar /GenomeAnalysisTK.jar -T HaplotypeCaller -R $(inputs.reference.path) -o $(inputs.input_bam.nameroot).vcf.gz -I local.sharded.bam -L $(inputs.interval_list.path) -ERC GVCF --max_alternate_alleles 3 -variant_index_parameter 128000 -variant_index_type LINEAR -contamination $(inputs.contamination) --read_filter OverclippedRead"
                }
            ],
            "inputs": [
                {
                    "type": "float",
                    "doc": "Fraction of contamination in sequencing data (for all samples) to aggressively remove",
                    "id": "#gatk_haplotypecaller.cwl/gatk_haplotypecaller/contamination"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "doc": "Input bam file",
                    "id": "#gatk_haplotypecaller.cwl/gatk_haplotypecaller/input_bam"
                },
                {
                    "type": "File",
                    "doc": "File containing one or more genomic intervals over which to operate",
                    "id": "#gatk_haplotypecaller.cwl/gatk_haplotypecaller/interval_list"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.dict",
                        ".fai"
                    ],
                    "doc": "Reference fasta with associated dict and fai indexes",
                    "id": "#gatk_haplotypecaller.cwl/gatk_haplotypecaller/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.vcf.gz"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#gatk_haplotypecaller.cwl/gatk_haplotypecaller/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#picard_collectalignmentsummarymetrics_conditional.cwl",
            "doc": "This tool collects alignment summary metrics on an input WGS/WXS bam.\nThe following programs are run in this tool:\n  - picard CollectAlignmentSummaryMetrics \nThis tool is also made to be used conditionally with the conditional_run parameter.\nSimply pass an empty array to conditional_run and scatter on the input to skip.",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 12000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/picard-r:latest-dev"
                }
            ],
            "baseCommand": [
                "java",
                "-Xms5000m",
                "-jar",
                "/picard.jar",
                "CollectAlignmentSummaryMetrics"
            ],
            "arguments": [
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "INPUT=$(inputs.input_bam.path) REFERENCE_SEQUENCE=$(inputs.reference.path) OUTPUT=$(inputs.input_bam.nameroot).alignmentsummary_metrics METRIC_ACCUMULATION_LEVEL=\"null\" METRIC_ACCUMULATION_LEVEL=\"SAMPLE\" METRIC_ACCUMULATION_LEVEL=\"LIBRARY\""
                }
            ],
            "inputs": [
                {
                    "type": "int",
                    "doc": "Placeholder variable to allow conditional running",
                    "id": "#picard_collectalignmentsummarymetrics_conditional.cwl/picard_collectalignmentsummarymetrics/conditional_run"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "doc": "Input bam file",
                    "id": "#picard_collectalignmentsummarymetrics_conditional.cwl/picard_collectalignmentsummarymetrics/input_bam"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "doc": "Reference fasta with dict and fai indexes",
                    "id": "#picard_collectalignmentsummarymetrics_conditional.cwl/picard_collectalignmentsummarymetrics/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.alignmentsummary_metrics"
                    },
                    "id": "#picard_collectalignmentsummarymetrics_conditional.cwl/picard_collectalignmentsummarymetrics/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#picard_collectgcbiasmetrics_conditional.cwl",
            "doc": "This tool collects gc bias metrics on an input WGS/WXS bam.\nThe following programs are run in this tool:\n  - picard CollectGcBiasMetrics\nThis tool is also made to be used conditionally with the conditional_run parameter.\nSimply pass an empty array to conditional_run and scatter on the input to skip.",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 12000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/picard-r:latest-dev"
                }
            ],
            "baseCommand": [
                "java",
                "-Xms5000m",
                "-jar",
                "/picard.jar",
                "CollectGcBiasMetrics"
            ],
            "arguments": [
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "INPUT=$(inputs.input_bam.path) REFERENCE_SEQUENCE=$(inputs.reference.path) OUTPUT=$(inputs.input_bam.nameroot).gc_bias_metrics.txt SUMMARY_OUTPUT=$(inputs.input_bam.nameroot).summary_metrics.txt CHART_OUTPUT=$(inputs.input_bam.nameroot).gc_bias_metrics.pdf METRIC_ACCUMULATION_LEVEL=\"null\" METRIC_ACCUMULATION_LEVEL=\"SAMPLE\" METRIC_ACCUMULATION_LEVEL=\"LIBRARY\""
                }
            ],
            "inputs": [
                {
                    "type": "int",
                    "doc": "Placeholder variable to allow conditional running",
                    "id": "#picard_collectgcbiasmetrics_conditional.cwl/picard_collectgcbiasmetrics/conditional_run"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "doc": "Input bam file",
                    "id": "#picard_collectgcbiasmetrics_conditional.cwl/picard_collectgcbiasmetrics/input_bam"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "doc": "Reference fasta with dict and fai indexes",
                    "id": "#picard_collectgcbiasmetrics_conditional.cwl/picard_collectgcbiasmetrics/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.gc_bias_metrics.pdf"
                    },
                    "id": "#picard_collectgcbiasmetrics_conditional.cwl/picard_collectgcbiasmetrics/chart"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.gc_bias_metrics.txt"
                    },
                    "id": "#picard_collectgcbiasmetrics_conditional.cwl/picard_collectgcbiasmetrics/detail"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.summary_metrics.txt"
                    },
                    "id": "#picard_collectgcbiasmetrics_conditional.cwl/picard_collectgcbiasmetrics/summary"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#picard_collectgvcfcallingmetrics.cwl",
            "doc": "This tool collects summary and per-sample metrics about variant calls in a VCF file.\nThe following programs are run in this tool:\n  - picard CollectVariantCallingMetrics",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 3000,
                    "coresMin": 16
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/picard:2.18.2-dev"
                }
            ],
            "baseCommand": [
                "java",
                "-Xms2000m",
                "-jar",
                "/picard.jar",
                "CollectVariantCallingMetrics"
            ],
            "arguments": [
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "INPUT=$(inputs.input_vcf.path) OUTPUT=$(inputs.final_gvcf_base_name) DBSNP=$(inputs.dbsnp_vcf.path) SEQUENCE_DICTIONARY=$(inputs.reference_dict.path) TARGET_INTERVALS=$(inputs.wgs_evaluation_interval_list.path) GVCF_INPUT=true THREAD_COUNT=16"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".idx"
                    ],
                    "doc": "dbsnp VCF file",
                    "id": "#picard_collectgvcfcallingmetrics.cwl/gatk_collectgvcfcallingmetrics/dbsnp_vcf"
                },
                {
                    "type": "string",
                    "doc": "String to use as the base filename for the output",
                    "id": "#picard_collectgvcfcallingmetrics.cwl/gatk_collectgvcfcallingmetrics/final_gvcf_base_name"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "doc": "Input VCF file",
                    "id": "#picard_collectgvcfcallingmetrics.cwl/gatk_collectgvcfcallingmetrics/input_vcf"
                },
                {
                    "type": "File",
                    "doc": "Reference dict index file",
                    "id": "#picard_collectgvcfcallingmetrics.cwl/gatk_collectgvcfcallingmetrics/reference_dict"
                },
                {
                    "type": "File",
                    "doc": "Target intervals to restrict analysis to",
                    "id": "#picard_collectgvcfcallingmetrics.cwl/gatk_collectgvcfcallingmetrics/wgs_evaluation_interval_list"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_metrics"
                    },
                    "id": "#picard_collectgvcfcallingmetrics.cwl/gatk_collectgvcfcallingmetrics/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#picard_collecthsmetrics_conditional.cwl",
            "doc": "This tool collects hs metrics on an input WXS bam.\nThe following programs are run in this tool:\n  - picard CollectHsMetrics\nThis tool is also made to be used conditionally with the conditional_run parameter.\nSimply pass an empty array to conditional_run and scatter on the input to skip.",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 8000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/picard:2.18.2-dev"
                }
            ],
            "baseCommand": [
                "java",
                "-Xms2000m",
                "-jar",
                "/picard.jar",
                "CollectHsMetrics"
            ],
            "arguments": [
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "INPUT=$(inputs.input_bam.path) REFERENCE_SEQUENCE=$(inputs.reference.path) BAIT_INTERVALS=$(inputs.bait_intervals.path) TARGET_INTERVALS=$(inputs.target_intervals.path) OUTPUT=$(inputs.input_bam.nameroot).hs_metrics"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "doc": "An interval list file that contains the locations of the baits used",
                    "id": "#picard_collecthsmetrics_conditional.cwl/picard_collecthsmetrics/bait_intervals"
                },
                {
                    "type": "int",
                    "doc": "Placeholder variable to allow conditional running",
                    "id": "#picard_collecthsmetrics_conditional.cwl/picard_collecthsmetrics/conditional_run"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "doc": "Input bam file",
                    "id": "#picard_collecthsmetrics_conditional.cwl/picard_collecthsmetrics/input_bam"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "doc": "Reference fasta with dict and fai indexes",
                    "id": "#picard_collecthsmetrics_conditional.cwl/picard_collecthsmetrics/reference"
                },
                {
                    "type": "File",
                    "doc": "An interval list file that contains the locations of the targets",
                    "id": "#picard_collecthsmetrics_conditional.cwl/picard_collecthsmetrics/target_intervals"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.hs_metrics"
                    },
                    "id": "#picard_collecthsmetrics_conditional.cwl/picard_collecthsmetrics/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#picard_collectinsertsizemetrics_conditional.cwl",
            "doc": "This tool collects insert size metrics on an input WGS/WXS bam.\nThe following programs are run in this tool:\n  - picard CollectInsertSizeMetrics\nThis tool is also made to be used conditionally with the conditional_run parameter.\nSimply pass an empty array to conditional_run and scatter on the input to skip.",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 12000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/picard-r:latest-dev"
                }
            ],
            "baseCommand": [
                "java",
                "-Xms5000m",
                "-jar",
                "/picard.jar",
                "CollectInsertSizeMetrics"
            ],
            "arguments": [
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "INPUT=$(inputs.input_bam.path) REFERENCE_SEQUENCE=$(inputs.reference.path) OUTPUT=$(inputs.input_bam.nameroot).insert_size_metrics HISTOGRAM_FILE=$(inputs.input_bam.nameroot).insert_size_Histogram.pdf METRIC_ACCUMULATION_LEVEL=\"null\" METRIC_ACCUMULATION_LEVEL=\"SAMPLE\" METRIC_ACCUMULATION_LEVEL=\"LIBRARY\""
                }
            ],
            "inputs": [
                {
                    "type": "int",
                    "doc": "Placeholder variable to allow conditional running",
                    "id": "#picard_collectinsertsizemetrics_conditional.cwl/picard_collectinsertsizemetrics/conditional_run"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "doc": "Input bam file",
                    "id": "#picard_collectinsertsizemetrics_conditional.cwl/picard_collectinsertsizemetrics/input_bam"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "doc": "Reference fasta with dict and fai indexes",
                    "id": "#picard_collectinsertsizemetrics_conditional.cwl/picard_collectinsertsizemetrics/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.insert_size_metrics"
                    },
                    "id": "#picard_collectinsertsizemetrics_conditional.cwl/picard_collectinsertsizemetrics/metrics"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.insert_size_Histogram.pdf"
                    },
                    "id": "#picard_collectinsertsizemetrics_conditional.cwl/picard_collectinsertsizemetrics/plot"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#picard_collectsequencingartifactmetrics_conditional.cwl",
            "doc": "This tool collects sequencing artifact metrics on an input WGS/WXS bam.\nThe following programs are run in this tool:\n  - picard CollectSequencingArtifactMetrics\nThis tool is also made to be used conditionally with the conditional_run parameter.\nSimply pass an empty array to conditional_run and scatter on the input to skip.",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 12000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/picard-r:latest-dev"
                }
            ],
            "baseCommand": [
                "java",
                "-Xms5000m",
                "-jar",
                "/picard.jar",
                "CollectSequencingArtifactMetrics"
            ],
            "arguments": [
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "INPUT=$(inputs.input_bam.path) REFERENCE_SEQUENCE=$(inputs.reference.path) OUTPUT=$(inputs.input_bam.nameroot).artifact_metrics"
                }
            ],
            "inputs": [
                {
                    "type": "int",
                    "doc": "Placeholder variable to allow conditional running",
                    "id": "#picard_collectsequencingartifactmetrics_conditional.cwl/picard_collectsequencingartifactmetrics/conditional_run"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "doc": "Input bam file",
                    "id": "#picard_collectsequencingartifactmetrics_conditional.cwl/picard_collectsequencingartifactmetrics/input_bam"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "doc": "Reference fasta with dict and fai indexes",
                    "id": "#picard_collectsequencingartifactmetrics_conditional.cwl/picard_collectsequencingartifactmetrics/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.bait_bias_detail_metrics"
                    },
                    "id": "#picard_collectsequencingartifactmetrics_conditional.cwl/picard_collectsequencingartifactmetrics/bait_bias_detail_metrics"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.bait_bias_summary_metrics"
                    },
                    "id": "#picard_collectsequencingartifactmetrics_conditional.cwl/picard_collectsequencingartifactmetrics/bait_bias_summary_metrics"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.error_summary_metrics"
                    },
                    "id": "#picard_collectsequencingartifactmetrics_conditional.cwl/picard_collectsequencingartifactmetrics/error_summary_metrics"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.pre_adapter_detail_metrics"
                    },
                    "id": "#picard_collectsequencingartifactmetrics_conditional.cwl/picard_collectsequencingartifactmetrics/pre_adapter_detail_metrics"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.pre_adapter_summary_metrics"
                    },
                    "id": "#picard_collectsequencingartifactmetrics_conditional.cwl/picard_collectsequencingartifactmetrics/pre_adapter_summary_metrics"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#picard_collectwgsmetrics_conditional.cwl",
            "doc": "This tool collects wgs metrics on an input WGS bam.\nThe following programs are run in this tool:\n  - picard CollectWgsMetrics\nThis tool is also made to be used conditionally with the conditional_run parameter.\nSimply pass an empty array to conditional_run and scatter on the input to skip.",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 8000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/picard:2.18.2-dev"
                }
            ],
            "baseCommand": [
                "java",
                "-Xms2000m",
                "-jar",
                "/picard.jar",
                "CollectWgsMetrics"
            ],
            "arguments": [
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "INPUT=$(inputs.input_bam.path) VALIDATION_STRINGENCY=SILENT REFERENCE_SEQUENCE=$(inputs.reference.path) INCLUDE_BQ_HISTOGRAM=true INTERVALS=$(inputs.intervals.path) OUTPUT=$(inputs.input_bam.nameroot).wgs_metrics USE_FAST_ALGORITHM=true READ_LENGTH=250"
                }
            ],
            "inputs": [
                {
                    "type": "int",
                    "doc": "Placeholder variable to allow conditional running",
                    "id": "#picard_collectwgsmetrics_conditional.cwl/picard_collectwgsmetrics/conditional_run"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "doc": "Input bam file",
                    "id": "#picard_collectwgsmetrics_conditional.cwl/picard_collectwgsmetrics/input_bam"
                },
                {
                    "type": "File",
                    "doc": "An interval list file that contains the positions to restrict the assessment",
                    "id": "#picard_collectwgsmetrics_conditional.cwl/picard_collectwgsmetrics/intervals"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "doc": "Reference fasta and fai index",
                    "id": "#picard_collectwgsmetrics_conditional.cwl/picard_collectwgsmetrics/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.input_bam.nameroot).wgs_metrics"
                    },
                    "id": "#picard_collectwgsmetrics_conditional.cwl/picard_collectwgsmetrics/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#picard_gatherbamfiles.cwl",
            "doc": "This program gathers the input bam files into a single bam.\nThe following programs are run in this program:\n  - picard GatherBamFiles\n  - rm",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/picard:2.18.2-dev"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 8000
                }
            ],
            "baseCommand": [],
            "arguments": [
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "rm_bams=\"${\n  var arr = [];\n  for (var i=0; i<inputs.input_bam.length; i++)\n      arr = arr.concat(inputs.input_bam[i].path)\n  return (arr.join(' '))\n}\"\ninput_bams=\"${\n  var arr = [];\n  for (var i=0; i<inputs.input_bam.length; i++)\n      arr = arr.concat(inputs.input_bam[i].path)\n  return (arr.join(' INPUT='))\n}\"\njava -Xms2000m -jar /picard.jar GatherBamFiles OUTPUT=$(inputs.output_bam_basename).bam INPUT=$input_bams CREATE_INDEX=true CREATE_MD5_FILE=true && rm $rm_bams"
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "doc": "Input bam file list",
                    "id": "#picard_gatherbamfiles.cwl/picard_gatherbamfiles/input_bam"
                },
                {
                    "type": "string",
                    "doc": "String to be used as the base filename for the output.",
                    "id": "#picard_gatherbamfiles.cwl/picard_gatherbamfiles/output_bam_basename"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.bam"
                    },
                    "secondaryFiles": [
                        "^.bai",
                        ".md5"
                    ],
                    "id": "#picard_gatherbamfiles.cwl/picard_gatherbamfiles/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#picard_intervallisttools.cwl",
            "doc": "This tool scatters a single interval list into many interval list files.\nThe following programs are run in this tool:\n  - picard IntervalListTools",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/picard:2.18.2-dev"
                }
            ],
            "baseCommand": [
                "java",
                "-Xmx2000m",
                "-jar",
                "/picard.jar"
            ],
            "arguments": [
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "IntervalListTools SCATTER_COUNT=50 SUBDIVISION_MODE=BALANCING_WITHOUT_INTERVAL_SUBDIVISION_WITH_OVERFLOW UNIQUE=true SORT=true BREAK_BANDS_AT_MULTIPLES_OF=1000000 INPUT=$(inputs.interval_list.path) OUTPUT=$(runtime.outdir)"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "doc": "Input interval list",
                    "id": "#picard_intervallisttools.cwl/picard_intervallisttools/interval_list"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "temp*/*.interval_list"
                    },
                    "id": "#picard_intervallisttools.cwl/picard_intervallisttools/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#picard_mergevcfs.cwl",
            "doc": "This tool merges many VCFs into a single VCF.\nThe following programs are run in this tool:\n  - picard MergeVcfs",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 3000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/picard:2.18.2-dev"
                }
            ],
            "baseCommand": [
                "java",
                "-Xms2000m",
                "-jar",
                "/picard.jar",
                "MergeVcfs"
            ],
            "arguments": [
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "OUTPUT=$(inputs.output_vcf_basename).g.vcf.gz"
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File",
                        "inputBinding": {
                            "prefix": "INPUT=",
                            "separate": false
                        }
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "doc": "List of input VCF files",
                    "id": "#picard_mergevcfs.cwl/picard_mergevcfs/input_vcf"
                },
                {
                    "type": "string",
                    "doc": "String to be used as the base filename for the output",
                    "id": "#picard_mergevcfs.cwl/picard_mergevcfs/output_vcf_basename"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.vcf.gz"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#picard_mergevcfs.cwl/picard_mergevcfs/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#picard_qualityscoredistribution_conditional.cwl",
            "doc": "This tool plots the quality score distribution found in an input WGS/WXS bam.\nThe following programs are run in this tool:\n  - picard QualityScoreDistribution\nThis tool is also made to be used conditionally with the conditional_run parameter.\nSimply pass an empty array to conditional_run and scatter on the input to skip.",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 12000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/picard-r:latest-dev"
                }
            ],
            "baseCommand": [
                "java",
                "-Xms5000m",
                "-jar",
                "/picard.jar",
                "QualityScoreDistribution"
            ],
            "arguments": [
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "INPUT=$(inputs.input_bam.path) REFERENCE_SEQUENCE=$(inputs.reference.path) OUTPUT=$(inputs.input_bam.nameroot).qual_score_dist.txt CHART_OUTPUT=$(inputs.input_bam.nameroot).qual_score_dist.pdf"
                }
            ],
            "inputs": [
                {
                    "type": "int",
                    "doc": "Placeholder variable to allow conditional running",
                    "id": "#picard_qualityscoredistribution_conditional.cwl/picard_qualityscoredistribution/conditional_run"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "doc": "Input bam file",
                    "id": "#picard_qualityscoredistribution_conditional.cwl/picard_qualityscoredistribution/input_bam"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "doc": "Reference fasta with dict and fai indexes",
                    "id": "#picard_qualityscoredistribution_conditional.cwl/picard_qualityscoredistribution/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.qual_score_dist.pdf"
                    },
                    "id": "#picard_qualityscoredistribution_conditional.cwl/picard_qualityscoredistribution/chart"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.qual_score_dist.txt"
                    },
                    "id": "#picard_qualityscoredistribution_conditional.cwl/picard_qualityscoredistribution/metrics"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#python_createsequencegroups.cwl",
            "doc": "Splits the reference dict file in a list of interval files. \nIntervals are determined by the longest SQ length in the dict.",
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/python:2.7.13"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "baseCommand": [
                "python",
                "-c"
            ],
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": true,
                    "valueFrom": "def main():\n    with open(\"$(inputs.ref_dict.path)\", \"r\") as ref_dict_file:\n        sequence_tuple_list = []\n        longest_sequence = 0\n        for line in ref_dict_file:\n            if line.startswith(\"@SQ\"):\n                line_split = line.split(\"\\t\")\n                sequence_tuple_list.append((line_split[1].split(\"SN:\")[1], int(line_split[2].split(\"LN:\")[1])))\n        longest_sequence = sorted(sequence_tuple_list, key=lambda x: x[1], reverse=True)[0][1]\n    hg38_protection_tag = \":1+\"\n    tsv_string = sequence_tuple_list[0][0] + hg38_protection_tag\n    temp_size = sequence_tuple_list[0][1]\n    i = 0\n    for sequence_tuple in sequence_tuple_list[1:]:\n        if temp_size + sequence_tuple[1] <= longest_sequence:\n            temp_size += sequence_tuple[1]\n            tsv_string += \"\\n\" + sequence_tuple[0] + hg38_protection_tag\n        else:\n            i += 1\n            pad = \"{:0>2d}\".format(i)\n            tsv_file_name = \"sequence_grouping_\" + pad + \".intervals\"\n            with open(tsv_file_name, \"w\") as tsv_file:\n                tsv_file.write(tsv_string)\n                tsv_file.close()\n            tsv_string = sequence_tuple[0] + hg38_protection_tag\n            temp_size = sequence_tuple[1]\n    i += 1\n    pad = \"{:0>2d}\".format(i)\n    tsv_file_name = \"sequence_grouping_\" + pad + \".intervals\"\n    with open(tsv_file_name, \"w\") as tsv_file:\n        tsv_file.write(tsv_string)\n        tsv_file.close()\n\n    with open(\"unmapped.intervals\", \"w\") as tsv_file:\n        tsv_file.write(\"unmapped\")\n        tsv_file.close()\n\nif __name__ == \"__main__\":\n    main()"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "doc": "Reference fasta dict file",
                    "id": "#python_createsequencegroups.cwl/python_createsequencegroups/ref_dict"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "sequence_grouping_*.intervals"
                    },
                    "id": "#python_createsequencegroups.cwl/python_createsequencegroups/sequence_intervals"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.intervals"
                    },
                    "id": "#python_createsequencegroups.cwl/python_createsequencegroups/sequence_intervals_with_unmapped"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#sambamba_merge_anylist.cwl",
            "doc": "Takes any list, flattens that list, then merges the items of the list.\nThis tool runs the following programs:\n  - sambamba merge && rm",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 2024,
                    "coresMin": 36
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "images.sbgenomics.com/bogdang/sambamba:0.6.3"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "baseCommand": [],
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": false,
                    "valueFrom": "bams=\"${\n  var flatin = [].concat.apply([],inputs.bams);\n  var arr = [];\n  for (var i=0; i<flatin.length; i++)\n    arr = arr.concat(flatin[i].path)\n  return(arr.join(' '))\n}\"\n/opt/sambamba_0.6.3/sambamba_v0.6.3 merge -t 36 $(inputs.base_file_name).aligned.duplicates_marked.unsorted.bam $bams && rm $bams"
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "Any"
                    },
                    "doc": "Input will be a combination of File[] and deeply nested File[]. Any[] is flexible enough to accomodate the different types",
                    "id": "#sambamba_merge_anylist.cwl/sambamba_merge_anylist/bams"
                },
                {
                    "type": "string",
                    "doc": "String to be used in naming the output bam",
                    "id": "#sambamba_merge_anylist.cwl/sambamba_merge_anylist/base_file_name"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.bam"
                    },
                    "secondaryFiles": [
                        ".bai",
                        "^.bai"
                    ],
                    "format": "#sambamba_merge_anylist.cwl/sambamba_merge_anylist/BAM",
                    "id": "#sambamba_merge_anylist.cwl/sambamba_merge_anylist/merged_bam"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#sambamba_sort.cwl",
            "doc": "This tool sorts the input bam.\nPrograms used by this tool:\n  - sambamba sort\n  - mv",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 15000,
                    "coresMin": 36
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "images.sbgenomics.com/bogdang/sambamba:0.6.3"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "baseCommand": [],
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": false,
                    "valueFrom": "/opt/sambamba_0.6.3/sambamba_v0.6.3 sort -t 36 -m 10G -o $(inputs.base_file_name).$(inputs.suffix).bam $(inputs.bam.path)\nmv $(inputs.base_file_name).$(inputs.suffix).bam.bai $(inputs.base_file_name).$(inputs.suffix).bai"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "doc": "Input bam file",
                    "id": "#sambamba_sort.cwl/sambamba_sort/bam"
                },
                {
                    "type": "string",
                    "doc": "String to be used as the base filename for the sorted bam",
                    "id": "#sambamba_sort.cwl/sambamba_sort/base_file_name"
                },
                {
                    "type": "string",
                    "default": "aligned.duplicates_marked.sorted",
                    "doc": "String suffix to be used for the sorted bam filename",
                    "id": "#sambamba_sort.cwl/sambamba_sort/suffix"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.bam"
                    },
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "format": "#sambamba_sort.cwl/sambamba_sort/BAM",
                    "id": "#sambamba_sort.cwl/sambamba_sort/sorted_bam"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#samtools_bam_to_cram.cwl",
            "doc": "This tool converts the input BAM into a CRAM.\nThe following programs are run in this tool:\n  - samtools view\n  - samtools index",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/samtools:1.8-dev"
                }
            ],
            "baseCommand": [
                "samtools",
                "view"
            ],
            "arguments": [
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "-C -T $(inputs.reference.path) -o $(inputs.input_bam.nameroot).cram $(inputs.input_bam.path) && samtools index $(inputs.input_bam.nameroot).cram"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "doc": "Input bam file",
                    "id": "#samtools_bam_to_cram.cwl/samtools_bam_to_cram/input_bam"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "doc": "Reference fasta with associated fai index",
                    "id": "#samtools_bam_to_cram.cwl/samtools_bam_to_cram/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.cram"
                    },
                    "secondaryFiles": [
                        ".crai"
                    ],
                    "id": "#samtools_bam_to_cram.cwl/samtools_bam_to_cram/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#samtools_split.cwl",
            "doc": "This tool splits the input bam input read group bams if it has more than one readgroup.\nPrograms run in this tool:\n  - samtools view | grep\n  - samtools split\nUsing samtools view and grep count the header lines starting with @RG. If that number is\nnot one, split the bam file into read group bams using samtools.",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/samtools:1.9"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "baseCommand": [
                "/bin/bash",
                "-c"
            ],
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": false,
                    "valueFrom": "set -eo pipefail\nRG_NUM=`samtools view -H $(inputs.input_bam.path) | grep -c ^@RG`\nif [ $RG_NUM != 1 ]; then\n  samtools split -f '%!.bam' -@ 36 --reference $(inputs.reference.path) $(inputs.input_bam.path)\nfi"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "doc": "Input bam file",
                    "id": "#samtools_split.cwl/samtools_split/input_bam"
                },
                {
                    "type": "File",
                    "doc": "Reference fasta file",
                    "id": "#samtools_split.cwl/samtools_split/reference"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.bam",
                        "outputEval": "${\n  if (self.length == 0) return [inputs.input_bam]\n  else return self\n}"
                    },
                    "id": "#samtools_split.cwl/samtools_split/bam_files"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#verifybamid_contamination.cwl",
            "doc": "This tool verifies whether the reads in particular file match previously known genotypes for an individual\nand checks whether the reads are contaminated as a mixture of two samples.\nThe following programs are run in this tool:\n  - VerifyBamID",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/verifybamid:1.0.2"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 5000,
                    "coresMin": 4
                }
            ],
            "baseCommand": [
                "/bin/VerifyBamID"
            ],
            "arguments": [
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "--Verbose --NumPC 4 --Output $(inputs.output_basename) --BamFile $(inputs.input_bam.path) --Reference $(inputs.ref_fasta.path) --UDPath $(inputs.contamination_sites_ud.path) --MeanPath $(inputs.contamination_sites_mu.path) --BedPath $(inputs.contamination_sites_bed.path) 1>/dev/null"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "doc": ".Bed file for markers used in this analysis,format(chr\tpos-1\tpos\trefAllele\taltAllele)",
                    "id": "#verifybamid_contamination.cwl/verifybamid_contamination/contamination_sites_bed"
                },
                {
                    "type": "File",
                    "doc": ".mu matrix file of genotype matrix",
                    "id": "#verifybamid_contamination.cwl/verifybamid_contamination/contamination_sites_mu"
                },
                {
                    "type": "File",
                    "doc": ".UD matrix file from SVD result of genotype matrix",
                    "id": "#verifybamid_contamination.cwl/verifybamid_contamination/contamination_sites_ud"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "doc": "Input bam file",
                    "id": "#verifybamid_contamination.cwl/verifybamid_contamination/input_bam"
                },
                {
                    "type": "string",
                    "doc": "String to be used as the base filename for the output",
                    "id": "#verifybamid_contamination.cwl/verifybamid_contamination/output_basename"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "doc": "Reference fasta and fai index",
                    "id": "#verifybamid_contamination.cwl/verifybamid_contamination/ref_fasta"
                }
            ],
            "outputs": [
                {
                    "type": "float",
                    "outputBinding": {
                        "glob": "*.selfSM",
                        "loadContents": true,
                        "outputEval": "${\n  var lines = self[0].contents.split('\\n');\n  for (var i = 1; i < lines.length; i++) {\n    var fields = lines[i].split('\\t');\n    if (fields.length != 19) {\n      continue;\n    }\n    return fields[6]/0.75;\n  }\n}"
                    },
                    "id": "#verifybamid_contamination.cwl/verifybamid_contamination/contamination"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.selfSM"
                    },
                    "id": "#verifybamid_contamination.cwl/verifybamid_contamination/output"
                }
            ]
        },
        {
            "class": "Workflow",
            "id": "#main",
            "doc": "# KFDRC Alignment Workflow\nWorkflow for the alignment or realignment of input BAMs, PE FASTQ reads, and/or SE FASTQ reads; conditionally generate gVCF and metrics.\n\n![data service logo](https://github.com/d3b-center/d3b-research-workflows/raw/master/doc/kfdrc-logo-sm.png)\n\nThis workflow is a all-in-one workflow for handling any kind of reads inputs: BAM inputs, PE reads\nand mates FASTQ inputs, SE reads FASTQ inputs,  or any combination of these. The workflow will naively attempt\nto process these depending on what you tell it you have provided. The user informs the workflow of\nwhich inputs to process using three boolean inputs: `run_bam_processing`, `run_pe_reads_processing`,\nand `run_se_reads_processing`. Providing `true` values for these as well their corresponding inputs\nwill result in those inputs being processed.\n\nThe second half of the workflow deals with optional gVCF creation and metrics collection.\nThis workflow is capable of collecting the metrics using the following boolean flags: `run_hs_metrics`,\n`run_wgs_metrics`, and `run_agg_metrics`. To run these metrics, additional optional inputs must\nalso be provided: `wxs_bait_interval_list` and `wxs_target_interval_list` for HsMetrics,\n`wgs_coverage_interval_list` for WgsMetrics. To generate the gVCF, set `run_gvcf_processing` to\n`true` and provide the following optional files: `dbsnp_vcf`, `contamination_sites_bed`,\n`contamination_sites_mu`, `contamination_sites_ud`, `wgs_calling_interval_list`, and\n`wgs_evaluation_interval_list`.\n\n ### Caveats:\n 1. Duplicates are flagged in a process that is connected to bwa mem. The implication of this design\n    decision is that duplicates are flagged only on the inputs of that are scattered into bwa.\n    Duplicates, therefore, are not being flagged at a library level and, for large BAM and FASTQ inputs,\n    duplicates are only being detected within a portion of the read group.\n\n ## Tips for running:\n 1. For the fastq input file lists (PE or SE), make sure the lists are properly ordered. The items in\n    the arrays are processed based on their position. These lists are dotproduct scattered. This means\n    that the first file in `input_pe_reads_list` is run with the first file in `input_pe_mates_list`\n    and the first string in `input_pe_rgs_list`. This also means these arrays must be the same\n    length or the workflow will fail.\n 1. Must have these associated indexes:\n    - knownsite vcfs: Each file requires a '.tbi' index\n    - reference fasta: BWA and samtools indexes ('.64.amb', '.64.ann', '.64.bwt',\n        '.64.pac', '.64.sa', '.64.alt', '^.dict', '.fai')\n 1. Turning off gVCF creation and metrics collection for a minimal successful run.\n 1. Suggested reference inputs (available from the [Broad Resource Bundle](https://console.cloud.google.com/storage/browser/genomics-public-data/resources/broad/hg38/v0)):\n    - contamination_sites_bed: Homo_sapiens_assembly38.contam.bed\n    - contamination_sites_mu: Homo_sapiens_assembly38.contam.mu\n    - contamination_sites_ud: Homo_sapiens_assembly38.contam.UD\n    - dbsnp_vcf: Homo_sapiens_assembly38.dbsnp138.vcf\n    - indexed_reference_fasta: Homo_sapiens_assembly38.fasta\n    - knownsites:\n      - Homo_sapiens_assembly38.known_indels.vcf.gz\n      - Mills_and_1000G_gold_standard.indels.hg38.vcf.gz\n      - 1000G_phase1.snps.high_confidence.hg38.vcf.gz\n      - 1000G_omni2.5.hg38.vcf.gz\n    - reference_dict: Homo_sapiens_assembly38.dict",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "doc": "String name of biospcimen",
                    "id": "#main/biospecimen_name"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "doc": ".Bed file for markers used in this analysis,format(chr\tpos-1\tpos\trefAllele\taltAllele)",
                    "id": "#main/contamination_sites_bed"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "doc": ".mu matrix file of genotype matrix",
                    "id": "#main/contamination_sites_mu"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "doc": ".UD matrix file from SVD result of genotype matrix",
                    "id": "#main/contamination_sites_ud"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "doc": "dbSNP vcf file",
                    "id": "#main/dbsnp_vcf"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".64.amb",
                        ".64.ann",
                        ".64.bwt",
                        ".64.pac",
                        ".64.sa",
                        ".64.alt",
                        "^.dict",
                        ".fai"
                    ],
                    "doc": "Reference fasta with BWA and samtool indexes",
                    "id": "#main/indexed_reference_fasta"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "doc": "List of input BAM files",
                    "id": "#main/input_bam_list"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "doc": "List of input R2 paired end fastq reads",
                    "id": "#main/input_pe_mates_list"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "doc": "List of input R1 paired end fastq reads",
                    "id": "#main/input_pe_reads_list"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "List of RG strings to use in PE processing",
                    "id": "#main/input_pe_rgs_list"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "doc": "List of input singlie end fastq reads",
                    "id": "#main/input_se_reads_list"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "List of RG strings to use in SE processing",
                    "id": "#main/input_se_rgs_list"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "doc": "List of files and indexes containing known polymorphic sites used to exclude regions around known polymorphisms from analysis",
                    "id": "#main/knownsites"
                },
                {
                    "type": "string",
                    "doc": "String to use as the base for output filenames",
                    "id": "#main/output_basename"
                },
                {
                    "type": "File",
                    "doc": "Dict index of the reference fasta",
                    "id": "#main/reference_dict"
                },
                {
                    "type": "boolean",
                    "doc": "AlignmentSummaryMetrics, GcBiasMetrics, InsertSizeMetrics, QualityScoreDistribution, and SequencingArtifactMetrics will be collected. Recommended for both WXS and WGS inputs.",
                    "id": "#main/run_agg_metrics"
                },
                {
                    "type": "boolean",
                    "doc": "BAM processing will be run. Requires: input_bam_list",
                    "id": "#main/run_bam_processing"
                },
                {
                    "type": "boolean",
                    "doc": "gVCF will be generated. Requires: dbsnp_vcf, contamination_sites_bed, contamination_sites_mu, contamination_sites_ud, wgs_calling_interval_list, wgs_evaluation_interval_list",
                    "id": "#main/run_gvcf_processing"
                },
                {
                    "type": "boolean",
                    "doc": "HsMetrics will be collected. Only recommended for WXS inputs. Requires: wxs_bait_interval_list, wxs_target_interval_list",
                    "id": "#main/run_hs_metrics"
                },
                {
                    "type": "boolean",
                    "doc": "PE reads processing will be run. Requires: input_pe_reads_list, input_pe_mates_list, input_pe_rgs_list",
                    "id": "#main/run_pe_reads_processing"
                },
                {
                    "type": "boolean",
                    "doc": "SE reads processing will be run. Requires: input_se_reads_list, input_se_rgs_list",
                    "id": "#main/run_se_reads_processing"
                },
                {
                    "type": "boolean",
                    "doc": "WgsMetrics will be collected. Only recommended for WGS inputs. Requires: wgs_coverage_interval_list",
                    "id": "#main/run_wgs_metrics"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "doc": "WGS interval list used to aid scattering Haplotype caller",
                    "id": "#main/wgs_calling_interval_list"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "doc": "An interval list file that contains the positions to restrict the wgs metrics assessment",
                    "id": "#main/wgs_coverage_interval_list"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "doc": "Target intervals to restrict gvcf metric analysis (for VariantCallingMetrics)",
                    "id": "#main/wgs_evaluation_interval_list"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "doc": "An interval list file that contains the locations of the WXS baits used (for HsMetrics)",
                    "id": "#main/wxs_bait_interval_list"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "doc": "An interval list file that contains the locations of the WXS targets (for HsMetrics)",
                    "id": "#main/wxs_target_interval_list"
                }
            ],
            "outputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "outputSource": "#main/picard_collectalignmentsummarymetrics/output",
                    "id": "#main/alignment_metrics"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "outputSource": "#main/picard_collectsequencingartifactmetrics/bait_bias_detail_metrics",
                    "id": "#main/artifact_bait_bias_detail_metrics"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "outputSource": "#main/picard_collectsequencingartifactmetrics/bait_bias_summary_metrics",
                    "id": "#main/artifact_bait_bias_summary_metrics"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "outputSource": "#main/picard_collectsequencingartifactmetrics/error_summary_metrics",
                    "id": "#main/artifact_error_summary_metrics"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "outputSource": "#main/picard_collectsequencingartifactmetrics/pre_adapter_detail_metrics",
                    "id": "#main/artifact_pre_adapter_detail_metrics"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "outputSource": "#main/picard_collectsequencingartifactmetrics/pre_adapter_summary_metrics",
                    "id": "#main/artifact_pre_adapter_summary_metrics"
                },
                {
                    "type": "File",
                    "outputSource": "#main/gatk_gatherbqsrreports/output",
                    "id": "#main/bqsr_report"
                },
                {
                    "type": "File",
                    "outputSource": "#main/samtools_bam_to_cram/output",
                    "id": "#main/cram"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "outputSource": "#main/picard_collectgcbiasmetrics/chart",
                    "id": "#main/gc_bias_chart"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "outputSource": "#main/picard_collectgcbiasmetrics/detail",
                    "id": "#main/gc_bias_detail"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "outputSource": "#main/picard_collectgcbiasmetrics/summary",
                    "id": "#main/gc_bias_summary"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "outputSource": "#main/generate_gvcf/gvcf",
                    "id": "#main/gvcf"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": {
                                "type": "array",
                                "items": "File"
                            }
                        }
                    ],
                    "outputSource": "#main/generate_gvcf/gvcf_calling_metrics",
                    "id": "#main/gvcf_calling_metrics"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "outputSource": "#main/picard_collecthsmetrics/output",
                    "id": "#main/hs_metrics"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "outputSource": "#main/picard_collectinsertsizemetrics/metrics",
                    "id": "#main/insert_metrics"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "outputSource": "#main/picard_collectinsertsizemetrics/plot",
                    "id": "#main/insert_plot"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "outputSource": "#main/picard_qualityscoredistribution/chart",
                    "id": "#main/qual_chart"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "outputSource": "#main/picard_qualityscoredistribution/metrics",
                    "id": "#main/qual_metrics"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "outputSource": "#main/generate_gvcf/verifybamid_output",
                    "id": "#main/verifybamid_output"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "outputSource": "#main/picard_collectwgsmetrics/output",
                    "id": "#main/wgs_metrics"
                }
            ],
            "steps": [
                {
                    "run": "#gatekeeper.cwl",
                    "in": [
                        {
                            "source": "#main/run_agg_metrics",
                            "id": "#main/gatekeeper/run_agg_metrics"
                        },
                        {
                            "source": "#main/run_bam_processing",
                            "id": "#main/gatekeeper/run_bam_processing"
                        },
                        {
                            "source": "#main/run_gvcf_processing",
                            "id": "#main/gatekeeper/run_gvcf_processing"
                        },
                        {
                            "source": "#main/run_hs_metrics",
                            "id": "#main/gatekeeper/run_hs_metrics"
                        },
                        {
                            "source": "#main/run_pe_reads_processing",
                            "id": "#main/gatekeeper/run_pe_reads_processing"
                        },
                        {
                            "source": "#main/run_se_reads_processing",
                            "id": "#main/gatekeeper/run_se_reads_processing"
                        },
                        {
                            "source": "#main/run_wgs_metrics",
                            "id": "#main/gatekeeper/run_wgs_metrics"
                        }
                    ],
                    "out": [
                        "#main/gatekeeper/scatter_bams",
                        "#main/gatekeeper/scatter_pe_reads",
                        "#main/gatekeeper/scatter_se_reads",
                        "#main/gatekeeper/scatter_gvcf",
                        "#main/gatekeeper/scatter_hs_metrics",
                        "#main/gatekeeper/scatter_wgs_metrics",
                        "#main/gatekeeper/scatter_agg_metrics"
                    ],
                    "id": "#main/gatekeeper"
                },
                {
                    "run": "#gatk_applybqsr.cwl",
                    "in": [
                        {
                            "source": "#main/gatk_gatherbqsrreports/output",
                            "id": "#main/gatk_applybqsr/bqsr_report"
                        },
                        {
                            "source": "#main/sambamba_sort/sorted_bam",
                            "id": "#main/gatk_applybqsr/input_bam"
                        },
                        {
                            "source": "#main/indexed_reference_fasta",
                            "id": "#main/gatk_applybqsr/reference"
                        },
                        {
                            "source": "#main/python_createsequencegroups/sequence_intervals_with_unmapped",
                            "id": "#main/gatk_applybqsr/sequence_interval"
                        }
                    ],
                    "scatter": [
                        "#main/gatk_applybqsr/sequence_interval"
                    ],
                    "out": [
                        "#main/gatk_applybqsr/recalibrated_bam"
                    ],
                    "id": "#main/gatk_applybqsr"
                },
                {
                    "run": "#gatk_baserecalibrator.cwl",
                    "in": [
                        {
                            "source": "#main/sambamba_sort/sorted_bam",
                            "id": "#main/gatk_baserecalibrator/input_bam"
                        },
                        {
                            "source": "#main/knownsites",
                            "id": "#main/gatk_baserecalibrator/knownsites"
                        },
                        {
                            "source": "#main/indexed_reference_fasta",
                            "id": "#main/gatk_baserecalibrator/reference"
                        },
                        {
                            "source": "#main/python_createsequencegroups/sequence_intervals",
                            "id": "#main/gatk_baserecalibrator/sequence_interval"
                        }
                    ],
                    "scatter": [
                        "#main/gatk_baserecalibrator/sequence_interval"
                    ],
                    "out": [
                        "#main/gatk_baserecalibrator/output"
                    ],
                    "id": "#main/gatk_baserecalibrator"
                },
                {
                    "run": "#gatk_gatherbqsrreports.cwl",
                    "in": [
                        {
                            "source": "#main/gatk_baserecalibrator/output",
                            "id": "#main/gatk_gatherbqsrreports/input_brsq_reports"
                        },
                        {
                            "source": "#main/output_basename",
                            "id": "#main/gatk_gatherbqsrreports/output_basename"
                        }
                    ],
                    "out": [
                        "#main/gatk_gatherbqsrreports/output"
                    ],
                    "id": "#main/gatk_gatherbqsrreports"
                },
                {
                    "run": "#kfdrc_bam_to_gvcf.cwl",
                    "in": [
                        {
                            "source": "#main/gatekeeper/scatter_gvcf",
                            "id": "#main/generate_gvcf/conditional_run"
                        },
                        {
                            "source": "#main/contamination_sites_bed",
                            "id": "#main/generate_gvcf/contamination_sites_bed"
                        },
                        {
                            "source": "#main/contamination_sites_mu",
                            "id": "#main/generate_gvcf/contamination_sites_mu"
                        },
                        {
                            "source": "#main/contamination_sites_ud",
                            "id": "#main/generate_gvcf/contamination_sites_ud"
                        },
                        {
                            "source": "#main/dbsnp_vcf",
                            "id": "#main/generate_gvcf/dbsnp_vcf"
                        },
                        {
                            "source": "#main/indexed_reference_fasta",
                            "id": "#main/generate_gvcf/indexed_reference_fasta"
                        },
                        {
                            "source": "#main/picard_gatherbamfiles/output",
                            "id": "#main/generate_gvcf/input_bam"
                        },
                        {
                            "source": "#main/output_basename",
                            "id": "#main/generate_gvcf/output_basename"
                        },
                        {
                            "source": "#main/reference_dict",
                            "id": "#main/generate_gvcf/reference_dict"
                        },
                        {
                            "source": "#main/wgs_calling_interval_list",
                            "id": "#main/generate_gvcf/wgs_calling_interval_list"
                        },
                        {
                            "source": "#main/wgs_evaluation_interval_list",
                            "id": "#main/generate_gvcf/wgs_evaluation_interval_list"
                        }
                    ],
                    "scatter": "#main/generate_gvcf/conditional_run",
                    "out": [
                        "#main/generate_gvcf/verifybamid_output",
                        "#main/generate_gvcf/gvcf",
                        "#main/generate_gvcf/gvcf_calling_metrics"
                    ],
                    "id": "#main/generate_gvcf"
                },
                {
                    "run": "#picard_collectalignmentsummarymetrics_conditional.cwl",
                    "in": [
                        {
                            "source": "#main/gatekeeper/scatter_agg_metrics",
                            "id": "#main/picard_collectalignmentsummarymetrics/conditional_run"
                        },
                        {
                            "source": "#main/picard_gatherbamfiles/output",
                            "id": "#main/picard_collectalignmentsummarymetrics/input_bam"
                        },
                        {
                            "source": "#main/indexed_reference_fasta",
                            "id": "#main/picard_collectalignmentsummarymetrics/reference"
                        }
                    ],
                    "scatter": "#main/picard_collectalignmentsummarymetrics/conditional_run",
                    "out": [
                        "#main/picard_collectalignmentsummarymetrics/output"
                    ],
                    "id": "#main/picard_collectalignmentsummarymetrics"
                },
                {
                    "run": "#picard_collectgcbiasmetrics_conditional.cwl",
                    "in": [
                        {
                            "source": "#main/gatekeeper/scatter_agg_metrics",
                            "id": "#main/picard_collectgcbiasmetrics/conditional_run"
                        },
                        {
                            "source": "#main/picard_gatherbamfiles/output",
                            "id": "#main/picard_collectgcbiasmetrics/input_bam"
                        },
                        {
                            "source": "#main/indexed_reference_fasta",
                            "id": "#main/picard_collectgcbiasmetrics/reference"
                        }
                    ],
                    "scatter": "#main/picard_collectgcbiasmetrics/conditional_run",
                    "out": [
                        "#main/picard_collectgcbiasmetrics/detail",
                        "#main/picard_collectgcbiasmetrics/summary",
                        "#main/picard_collectgcbiasmetrics/chart"
                    ],
                    "id": "#main/picard_collectgcbiasmetrics"
                },
                {
                    "run": "#picard_collecthsmetrics_conditional.cwl",
                    "in": [
                        {
                            "source": "#main/wxs_bait_interval_list",
                            "id": "#main/picard_collecthsmetrics/bait_intervals"
                        },
                        {
                            "source": "#main/gatekeeper/scatter_hs_metrics",
                            "id": "#main/picard_collecthsmetrics/conditional_run"
                        },
                        {
                            "source": "#main/picard_gatherbamfiles/output",
                            "id": "#main/picard_collecthsmetrics/input_bam"
                        },
                        {
                            "source": "#main/indexed_reference_fasta",
                            "id": "#main/picard_collecthsmetrics/reference"
                        },
                        {
                            "source": "#main/wxs_target_interval_list",
                            "id": "#main/picard_collecthsmetrics/target_intervals"
                        }
                    ],
                    "scatter": "#main/picard_collecthsmetrics/conditional_run",
                    "out": [
                        "#main/picard_collecthsmetrics/output"
                    ],
                    "id": "#main/picard_collecthsmetrics"
                },
                {
                    "run": "#picard_collectinsertsizemetrics_conditional.cwl",
                    "in": [
                        {
                            "source": "#main/gatekeeper/scatter_agg_metrics",
                            "id": "#main/picard_collectinsertsizemetrics/conditional_run"
                        },
                        {
                            "source": "#main/picard_gatherbamfiles/output",
                            "id": "#main/picard_collectinsertsizemetrics/input_bam"
                        },
                        {
                            "source": "#main/indexed_reference_fasta",
                            "id": "#main/picard_collectinsertsizemetrics/reference"
                        }
                    ],
                    "scatter": "#main/picard_collectinsertsizemetrics/conditional_run",
                    "out": [
                        "#main/picard_collectinsertsizemetrics/metrics",
                        "#main/picard_collectinsertsizemetrics/plot"
                    ],
                    "id": "#main/picard_collectinsertsizemetrics"
                },
                {
                    "run": "#picard_collectsequencingartifactmetrics_conditional.cwl",
                    "in": [
                        {
                            "source": "#main/gatekeeper/scatter_agg_metrics",
                            "id": "#main/picard_collectsequencingartifactmetrics/conditional_run"
                        },
                        {
                            "source": "#main/picard_gatherbamfiles/output",
                            "id": "#main/picard_collectsequencingartifactmetrics/input_bam"
                        },
                        {
                            "source": "#main/indexed_reference_fasta",
                            "id": "#main/picard_collectsequencingartifactmetrics/reference"
                        }
                    ],
                    "scatter": "#main/picard_collectsequencingartifactmetrics/conditional_run",
                    "out": [
                        "#main/picard_collectsequencingartifactmetrics/bait_bias_detail_metrics",
                        "#main/picard_collectsequencingartifactmetrics/bait_bias_summary_metrics",
                        "#main/picard_collectsequencingartifactmetrics/error_summary_metrics",
                        "#main/picard_collectsequencingartifactmetrics/pre_adapter_detail_metrics",
                        "#main/picard_collectsequencingartifactmetrics/pre_adapter_summary_metrics"
                    ],
                    "id": "#main/picard_collectsequencingartifactmetrics"
                },
                {
                    "run": "#picard_collectwgsmetrics_conditional.cwl",
                    "in": [
                        {
                            "source": "#main/gatekeeper/scatter_wgs_metrics",
                            "id": "#main/picard_collectwgsmetrics/conditional_run"
                        },
                        {
                            "source": "#main/picard_gatherbamfiles/output",
                            "id": "#main/picard_collectwgsmetrics/input_bam"
                        },
                        {
                            "source": "#main/wgs_coverage_interval_list",
                            "id": "#main/picard_collectwgsmetrics/intervals"
                        },
                        {
                            "source": "#main/indexed_reference_fasta",
                            "id": "#main/picard_collectwgsmetrics/reference"
                        }
                    ],
                    "scatter": "#main/picard_collectwgsmetrics/conditional_run",
                    "out": [
                        "#main/picard_collectwgsmetrics/output"
                    ],
                    "id": "#main/picard_collectwgsmetrics"
                },
                {
                    "run": "#picard_gatherbamfiles.cwl",
                    "in": [
                        {
                            "source": "#main/gatk_applybqsr/recalibrated_bam",
                            "id": "#main/picard_gatherbamfiles/input_bam"
                        },
                        {
                            "source": "#main/output_basename",
                            "id": "#main/picard_gatherbamfiles/output_bam_basename"
                        }
                    ],
                    "out": [
                        "#main/picard_gatherbamfiles/output"
                    ],
                    "id": "#main/picard_gatherbamfiles"
                },
                {
                    "run": "#picard_qualityscoredistribution_conditional.cwl",
                    "in": [
                        {
                            "source": "#main/gatekeeper/scatter_agg_metrics",
                            "id": "#main/picard_qualityscoredistribution/conditional_run"
                        },
                        {
                            "source": "#main/picard_gatherbamfiles/output",
                            "id": "#main/picard_qualityscoredistribution/input_bam"
                        },
                        {
                            "source": "#main/indexed_reference_fasta",
                            "id": "#main/picard_qualityscoredistribution/reference"
                        }
                    ],
                    "scatter": "#main/picard_qualityscoredistribution/conditional_run",
                    "out": [
                        "#main/picard_qualityscoredistribution/metrics",
                        "#main/picard_qualityscoredistribution/chart"
                    ],
                    "id": "#main/picard_qualityscoredistribution"
                },
                {
                    "run": "#kfdrc_process_bamlist.cwl",
                    "in": [
                        {
                            "source": "#main/gatekeeper/scatter_bams",
                            "id": "#main/process_bams/conditional_run"
                        },
                        {
                            "source": "#main/indexed_reference_fasta",
                            "id": "#main/process_bams/indexed_reference_fasta"
                        },
                        {
                            "source": "#main/input_bam_list",
                            "id": "#main/process_bams/input_bam_list"
                        },
                        {
                            "source": "#main/biospecimen_name",
                            "id": "#main/process_bams/sample_name"
                        }
                    ],
                    "scatter": "#main/process_bams/conditional_run",
                    "out": [
                        "#main/process_bams/unsorted_bams"
                    ],
                    "id": "#main/process_bams"
                },
                {
                    "run": "#kfdrc_process_pe_readslist2.cwl",
                    "in": [
                        {
                            "source": "#main/gatekeeper/scatter_pe_reads",
                            "id": "#main/process_pe_reads/conditional_run"
                        },
                        {
                            "source": "#main/indexed_reference_fasta",
                            "id": "#main/process_pe_reads/indexed_reference_fasta"
                        },
                        {
                            "source": "#main/input_pe_mates_list",
                            "id": "#main/process_pe_reads/input_pe_mates_list"
                        },
                        {
                            "source": "#main/input_pe_reads_list",
                            "id": "#main/process_pe_reads/input_pe_reads_list"
                        },
                        {
                            "source": "#main/input_pe_rgs_list",
                            "id": "#main/process_pe_reads/input_pe_rgs_list"
                        }
                    ],
                    "scatter": "#main/process_pe_reads/conditional_run",
                    "out": [
                        "#main/process_pe_reads/unsorted_bams"
                    ],
                    "id": "#main/process_pe_reads"
                },
                {
                    "run": "#kfdrc_process_se_readslist2.cwl",
                    "in": [
                        {
                            "source": "#main/gatekeeper/scatter_se_reads",
                            "id": "#main/process_se_reads/conditional_run"
                        },
                        {
                            "source": "#main/indexed_reference_fasta",
                            "id": "#main/process_se_reads/indexed_reference_fasta"
                        },
                        {
                            "source": "#main/input_se_reads_list",
                            "id": "#main/process_se_reads/input_se_reads_list"
                        },
                        {
                            "source": "#main/input_se_rgs_list",
                            "id": "#main/process_se_reads/input_se_rgs_list"
                        }
                    ],
                    "scatter": "#main/process_se_reads/conditional_run",
                    "out": [
                        "#main/process_se_reads/unsorted_bams"
                    ],
                    "id": "#main/process_se_reads"
                },
                {
                    "run": "#python_createsequencegroups.cwl",
                    "in": [
                        {
                            "source": "#main/reference_dict",
                            "id": "#main/python_createsequencegroups/ref_dict"
                        }
                    ],
                    "out": [
                        "#main/python_createsequencegroups/sequence_intervals",
                        "#main/python_createsequencegroups/sequence_intervals_with_unmapped"
                    ],
                    "id": "#main/python_createsequencegroups"
                },
                {
                    "hints": [
                        {
                            "class": "https://sevenbridges.comAWSInstanceType",
                            "value": "c5.9xlarge;ebs-gp2;2048"
                        }
                    ],
                    "run": "#sambamba_merge_anylist.cwl",
                    "in": [
                        {
                            "source": [
                                "#main/process_bams/unsorted_bams",
                                "#main/process_pe_reads/unsorted_bams",
                                "#main/process_se_reads/unsorted_bams"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/sambamba_merge/bams"
                        },
                        {
                            "source": "#main/output_basename",
                            "id": "#main/sambamba_merge/base_file_name"
                        }
                    ],
                    "out": [
                        "#main/sambamba_merge/merged_bam"
                    ],
                    "id": "#main/sambamba_merge"
                },
                {
                    "hints": [
                        {
                            "class": "https://sevenbridges.comAWSInstanceType",
                            "value": "c5.9xlarge;ebs-gp2;2048"
                        }
                    ],
                    "run": "#sambamba_sort.cwl",
                    "in": [
                        {
                            "source": "#main/sambamba_merge/merged_bam",
                            "id": "#main/sambamba_sort/bam"
                        },
                        {
                            "source": "#main/output_basename",
                            "id": "#main/sambamba_sort/base_file_name"
                        }
                    ],
                    "out": [
                        "#main/sambamba_sort/sorted_bam"
                    ],
                    "id": "#main/sambamba_sort"
                },
                {
                    "run": "#samtools_bam_to_cram.cwl",
                    "in": [
                        {
                            "source": "#main/picard_gatherbamfiles/output",
                            "id": "#main/samtools_bam_to_cram/input_bam"
                        },
                        {
                            "source": "#main/indexed_reference_fasta",
                            "id": "#main/samtools_bam_to_cram/reference"
                        }
                    ],
                    "out": [
                        "#main/samtools_bam_to_cram/output"
                    ],
                    "id": "#main/samtools_bam_to_cram"
                }
            ],
            "hints": [
                {
                    "class": "https://sevenbridges.commaxNumberOfParallelInstances",
                    "value": 6
                }
            ]
        }
    ],
    "cwlVersion": "v1.0",
    "$namespaces": {
        "sbg": "https://sevenbridges.com"
    }
}
